--lastchat
ChatManager.last_message = ""
if HUDChat then
	function HUDChat:key_press(o, k)
		if self._skip_first then
			self._skip_first = false
			return
		end
		if not self._enter_text_set then
			self._input_panel:enter_text(callback(self, self, "enter_text"))
			self._enter_text_set = true
		end
		local text = self._input_panel:child("input_text")
		local s, e = text:selection()
		local n = utf8.len(text:text())
		local d = math.abs(e - s)
		self._key_pressed = k
		text:stop()
		text:animate(callback(self, self, "update_key_down"), k)
		if k == Idstring("backspace") then
			if s == e and s > 0 then
				text:set_selection(s - 1, e)
			end
			text:replace_text("")
			if not (utf8.len(text:text()) < 1) or type(self._esc_callback) ~= "number" then
			end
		elseif k == Idstring("delete") then
			if s == e and s < n then
				text:set_selection(s, e + 1)
			end
			text:replace_text("")
			if not (utf8.len(text:text()) < 1) or type(self._esc_callback) ~= "number" then
			end
		elseif k == Idstring("insert") then
			local clipboard = Application:get_clipboard() or ""
			text:replace_text(clipboard)
			local lbs = text:line_breaks()
			if #lbs > 1 then
				local s = lbs[2]
				local e = utf8.len(text:text())
				text:set_selection(s, e)
				text:replace_text("")
			end
		elseif k == Idstring("up") then
			log("up'd")
			if ChatManager and ChatManager.last_message then	
				local last_message = ChatManager.last_message
				text:set_text(last_message)
				DelayedCalls:Add("lastmessage"..tostring(Application:time()), 1, function() text:set_selection(n, n) end)
				text:set_selection(n, n)
			end
		elseif k == Idstring("left") then
			if s < e then
				text:set_selection(s, s)
			elseif s > 0 then
				text:set_selection(s - 1, s - 1)
			end
		elseif k == Idstring("right") then
			if s < e then
				text:set_selection(e, e)
			elseif s < n then
				text:set_selection(s + 1, s + 1)
			end
		elseif self._key_pressed == Idstring("end") then
			text:set_selection(n, n)
		elseif self._key_pressed == Idstring("home") then
			text:set_selection(0, 0)
		elseif k == Idstring("enter") then
			if #text:text() > 1 then
				ChatManager.last_message = text:text()
			end
			if type(self._enter_callback) ~= "number" then
				self._enter_callback()
			end
		elseif k == Idstring("esc") and type(self._esc_callback) ~= "number" then
			text:set_text("")
			text:set_selection(0, 0)
			self._esc_callback()
		end
		self:update_caret()
	end
	log("\thudchat.lua | HUDChat Initialized!")
else
	log("\t\tchatmanager.lua | HUDChat failed to initialize!")
end
